package yrpg.fi.fibd.plugin.other;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.openapi.api.result.ApiSaveResult;
import kd.bos.openapi.api.result.BaseFilterResult;
import kd.bos.openapi.common.custom.annotation.ApiController;
import kd.bos.openapi.common.custom.annotation.ApiParam;
import kd.bos.openapi.common.custom.annotation.ApiPostMapping;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.openapi.common.result.OpenApiResult;
import kd.bos.openapi.common.util.OpenApiSdkUtil;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;




import javax.validation.Valid;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@ApiController(value="CommonBill",desc="统一url入口")
public class AccountViewApiController {
    //存放实际地址和接口入口的
    @ApiPostMapping(value="AccountViewURLApiHandler")
    public CustomApiResult<Object> AccountViewApiHandler(@Valid @ApiParam("入口参数") ApiReqModel reqModel){
        Map<String,Object> resultMap = new HashMap<>();
        List<Map<String, Object>> resultList = new ArrayList<>();
        BaseFilterResult responseData = new BaseFilterResult();
        CustomApiResult finalResult =new CustomApiResult();


        try {
            //获取入参
            String reqdata=reqModel.getData();
            JSONArray dataArray = JSONObject.parseArray(reqdata);
            // 新增（修改）、启用（解封）、禁用（封存） 入参
            JSONObject saveDataJson = new JSONObject();
            JSONObject freezeDataJson = new JSONObject();
            JSONObject unfreezeDataJson = new JSONObject();
            //解封时更新
            JSONObject unfreezeUpdateDataJson = new JSONObject();

            // 新增（修改）、启用（解封）、禁用（封存） data层参数
            JSONArray viewData = new JSONArray();
            JSONArray freezeNums = new JSONArray();
            JSONArray unfreezeNums = new JSONArray();
            //解封时更新
            JSONArray unfreezeData = new JSONArray();

            JSONObject freezeNumsJson = new JSONObject();
            JSONObject unfreezeNumsJson = new JSONObject();

            //取出所有入参的主键
            List<String> mainids = new ArrayList<String>();
            for(int i=0;i<dataArray.size();i++){
                JSONObject jsonObject = dataArray.getJSONObject(i);
                String number = jsonObject.getString("yrpg_key");
                mainids.add(number);
            }

            //获取已存在的会计科目
            QFilter mainidFilter = new QFilter("yrpg_key", QCP.in,mainids);
            DynamicObjectCollection accountView = QueryServiceHelper.query("bd_accountview", "number,yrpg_key,enable", new QFilter[]{mainidFilter});
            Map<String,Boolean> accountViewStatusMap = new HashMap<String,Boolean>();
            Map<String,String> accountViewNumMap = new HashMap<String,String>();
            for (DynamicObject view : accountView){
                accountViewStatusMap.put(view.getString("yrpg_key"),view.getBoolean("enable"));
                accountViewNumMap.put(view.getString("number"),view.getString("yrpg_key"));
            }

            //新增废弃数据，执行跳过，接口返回参数
            JSONArray newfreezeData = new JSONArray();
            //循环判断部门进入保存、封存、解封集合
            for(int i=0;i<dataArray.size();i++){
                JSONObject jsonObject = dataArray.getJSONObject(i);
                String number = jsonObject.getString("yrpg_key");
                boolean isfreeze = jsonObject.getBoolean("isfreeze");
                //根据入参是否封存，已经系统中状态判断
                if(accountViewStatusMap.get(number)==null&&isfreeze){
                    newfreezeData.add(jsonObject);
                    //封存新增直接跳过
                    continue;
                }
                if(accountViewStatusMap.get(number)==null){
                    //新增
                    viewData.add(jsonObject);
                }else if(!isfreeze&&accountViewStatusMap.get(number)){
                    //更新
                    viewData.add(jsonObject);
                }else if(accountViewStatusMap.get(number)&&isfreeze){
                    //封存
                    freezeNums.add(number);
                }
                else if(!accountViewStatusMap.get(number)&&!isfreeze){
                    //反封存以及更新
                    unfreezeNums.add(number);
                    unfreezeData.add(jsonObject);
                }
            }



            //返回值
            int successCount = 0;
            int failCount = 0;


            //判断是否调用封存解封
            boolean isfreeze = false;

            //调用封存接口
            if(!freezeNums.isEmpty()){
                isfreeze = true;
                freezeNumsJson.put("yrpg_key",freezeNums);
                freezeDataJson.put("data",freezeNumsJson);
                //调用接口
                OpenApiResult freeze = OpenApiSdkUtil.invoke("/v2/yrpg/fibd/bd_accountview/AccountViewDisable", freezeDataJson, new HashMap<>());

                //出参

                BaseFilterResult data = (BaseFilterResult)freeze.getData();
                ApiResponseUtil.freezeResult(data,accountViewNumMap,resultList);
                successCount=successCount+(int)data.getSuccessCount();
                failCount=failCount+(int)data.getFailCount();


            }

            //调用解封接口
            if(!unfreezeNums.isEmpty()){
                unfreezeNumsJson.put("yrpg_key",unfreezeNums);
                unfreezeDataJson.put("data",unfreezeNumsJson);
                //调用接口
                OpenApiResult viewunfreeze = OpenApiSdkUtil.invoke("/v2/yrpg/fibd/bd_accountview/AccountViewEnable", unfreezeDataJson, new HashMap<>());
                unfreezeUpdateDataJson.put("data",unfreezeData);
                //调用接口
                OpenApiResult viewsave = OpenApiSdkUtil.invoke("/v2/yrpg/fibd/bd_accountview/AccountViewSave", unfreezeUpdateDataJson, new HashMap<>());
                ApiSaveResult data = (ApiSaveResult)viewsave.getData();
                //根据查询更新操作返回值结构，将保存返回值组装
                ApiResponseUtil.assembleResult(data,responseData,isfreeze,resultList);
                successCount=successCount+(int)data.getSuccessCount();
                failCount=failCount+(int)data.getFailCount();

            }


            //调用保存接口
            if(!viewData.isEmpty()){
                saveDataJson.put("data",viewData);
                //调用接口
                OpenApiResult viewsave = OpenApiSdkUtil.invoke("/v2/yrpg/fibd/bd_accountview/AccountViewSave", saveDataJson, new HashMap<>());
                ApiSaveResult data = (ApiSaveResult)viewsave.getData();
                //根据查询更新操作返回值结构，将保存返回值组装
                ApiResponseUtil.assembleResult(data,responseData,isfreeze,resultList);
                successCount=successCount+(int)data.getSuccessCount();
                failCount=failCount+(int)data.getFailCount();
            }

            if(!newfreezeData.isEmpty()){
                ApiResponseUtil.newFreezeResult(newfreezeData,resultList);
                successCount=successCount+newfreezeData.size();
            }
            //多类型接口 过滤默认为空
            responseData.setFilter("");
            resultMap.put("mdMappings",resultList);
            resultMap.put("success",true);
            resultMap.put("message","本次成功"+successCount+"条，失败"+failCount+"条。");

        }catch (Exception e){
            resultMap.put("message",e.getMessage()+ e.getStackTrace().toString());
            resultMap.put("success",false);
        }finally {
            finalResult=CustomApiResult.success(resultMap);

        }
        return finalResult;



    }
}
